<?php

  function i2x($i,$j,$flip) {
    global $H,$R,$C,$T,$G,$GG;
    $GG=80;
    $XX=0.866*($GG+($GG*$R));
    $YY=$GG/2+($GG*$H);
    $x=0.866*($GG+($GG*$i));
    return ($flip) ? $XX-$x : $x;
    }

  function j2y($i,$j) {
    global $H,$R,$C,$T,$G,$GG;
    $XX=0.866*($GG+($GG*$R));
    $YY=$GG/2+($GG*$H);
    $y=$GG+($GG*$j);
    if (($T['R']==0)&&(($i%2)==0)) $y-=($GG/2);  // Condensor Coil
    if (($T['R']==1)&&(($i%2)==0)) $y-=($GG/2);  // Evaportor Coil (Invert)
    if (($T['R']==2)&&(($i%2)!=0)) $y-=($GG/2);  // Condensor Coil (Invert)
    if (($T['R']==3)&&(($i%2)!=0)) $y-=($GG/2);  // Evaportor Coil
    if ($T['R']==1) $y=$YY-$y;
    if ($T['R']==3) $y=$YY-$y;
    return $y;
    }

  function drawGraph($flip=FALSE) {
    global $H,$R,$C,$G,$T,$GG;
    $GG=80;
    $XX=0.866*($GG+($GG*$R));
    $YY=$GG/2+($GG*$H);
    $im = ImageCreate($XX,$YY);
    $white = ImageColorAllocate($im,0xFF,0xFF,0xFF);
    $black = ImageColorAllocate($im,0x0,0x0,0x0);
    $magenta = ImageColorAllocate($im,0xFF,0x0,0xFF);
    $color[0] = ImageColorAllocate($im,0xFF,0x0,0x0);
    $color[1] = ImageColorAllocate($im,0xFF,0xFF,0x0);
    $color[2] = ImageColorAllocate($im,0x0,0xFF,0x0);
    $color[3] = ImageColorAllocate($im,0x0,0xFF,0xFF);
    for ($j=0;$j<$H;++$j) {
      for ($i=0;$i<$R;++$i) {
        if (($G[$i][$j][0]>=0) && ($G[$i][$j][1]>=0) &&
            ($G[$i][$j][2]>=0) && ($G[$i][$j][3]>=0) && ($G[$G[$i][$j][2]][$G[$i][$j][3]][1]>=0))  {
          if (($G[$i][$j][1]%2)!=0) ImageSetThickness($im,($flip) ? $GG/20 : $GG/5);
            else ImageSetThickness($im,($flip) ? $GG/5 : $GG/20);
          ImageLine($im,i2x($i,$j,$flip),j2y($i,$j),i2x($G[$i][$j][2],$G[$i][$j][3],$flip),j2y($G[$i][$j][2],$G[$i][$j][3]),$black);
          }
        }
      }
    ImageSetThickness($im,1);
    for ($j=0,$i=0,$k=-1;$j<$H;++$j) {
      if (($G[$i][$j][0]>=0) && ($k!=$G[$i][$j][0])) { // Mark first point
        ImageFilledEllipse($im, i2x($i,$j,$flip), j2y($i,$j), ($GG/3)+($GG/4), ($GG/3)+($GG/4), $magenta);
        $k=$G[$i][$j][0];
        }
      }
    if (TRUE) { // ($T['O']==1)($T['O']==1) {
      for ($j=($H-1),$i=($R-1),$k=-1;$j>=0;--$j) {
        if (($G[$i][$j][0]>=0) && ($k!=$G[$i][$j][0])) { // Mark last point
          ImageFilledEllipse($im, i2x($i,$j,$flip), j2y($i,$j), ($GG/3)+($GG/4), ($GG/3)+($GG/4), $magenta);
          $k=$G[$i][$j][0];
          }
        }
      }
    // $font='/home/ktech/www/project/korn/39335_UniversCondensed.ttf';
    $font='/home/automation/www/ars/39335_UniversCondensed.ttf';
    for ($j=0;$j<$H;++$j) {
      for ($i=0;$i<$R;++$i) {
        ImageFilledEllipse($im, i2x($i,$j,$flip), j2y($i,$j), ($GG/2), ($GG/2), $black);
        if ($G[$i][$j][0]>=0) {
          if (($G[$i][$j][4]<0) && ($G[$i][$j][5]<0)) $GGG=$GG/2/2;
            else if (($G[$i][$j][2]<0) && ($G[$i][$j][3]<0)) $GGG=$GG/2/2;
            else $GGG=1;
          ImageFilledEllipse($im, i2x($i,$j,$flip), j2y($i,$j), ($GG/2)-$GGG, ($GG/2)-$GGG, $color[$G[$i][$j][0]%4]);
          }
        if (($G[$i][$j][0]>=0)&&($G[$i][$j][1]>=0)) {
          $txt=($G[$i][$j][0]+1).'.'.($G[$i][$j][1]+1);
          $textSize=ImageTTFBbox($GG/8,0,$font,$txt);
          ImageTTFText($im,$GG/8,0,i2x($i,$j,$flip)-(($textSize[4]-$textSize[0])/2),j2y($i,$j)-(($textSize[5]-$textSize[1])/2),$black,$font,$txt);
          }
        }
      }
    return $im;
    }

  ?>
