<?php
  require 'route.php';
  require 'draw.php';

  function createGraph($option) {
    global $H,$R,$C,$T,$G;
    $holePerCircuit=($H*$R)/$C;
    $sum=0;
    $TT=$T['P'];
    for ($c=0;$c<$C;++$c) {
      $holeAmount[$c]=floor(($c+1)*$holePerCircuit)-$sum;
      if ($TT=='E') if (($holeAmount[$c]%2)!=0) { $holeAmount[$c]--;}
      if ($TT=='O') if (($holeAmount[$c]%2)==0) { $holeAmount[$c]--;}
      $sum+=$holeAmount[$c];
      }
    $k=$c=0;
    for ($j=0;$j<$H;++$j) for ($i=0;$i<$R;++$i) $G[$i][$j][0]=-1;
    for ($c=0;$c<$C;++$c) {
      // for ($j=0;($j<$H)&&($G[0][$j][0]>=0);++$j);
      // $G[0][$j][0]=$c;
      $k=0;
      $backward=FALSE;
      $firstRow=-1;
      for ($j=0;$j<$H;++$j) {
        for ($i=0;$i<$R;++$i) {
          if ($backward==FALSE) $ii=$i;
            else if ($option==0) $ii=$R-$i-1;
            else if ((($T['R']==0)||($T['R']==1))&&($option==1)&&(($R%2)!=0)) $ii=((($R-$i)*2)-1)%$R;
            else if ((($T['R']==0)||($T['R']==1))&&($option==1)) $ii=((($R-$i)*2)-1)%($R+1);
            else if ((($T['R']==2)||($T['R']==3))&&($option==1)&&(($R%2)!=0)) $ii=((($R-$i)*2)+3)%$R;
            else if ((($T['R']==2)||($T['R']==3))&&($option==1)&&($i<($R/2))) $ii=(($R-$i)*2)%($R+1);
            else if ((($T['R']==2)||($T['R']==3))&&($option==1)) $ii=(($R-$i)*2)-2;
          if ($G[$ii][$j][0]<0) {
            $firstRow=1;
            $G[$ii][$j][0]=$c;
            $k++;
            if ($k>=$holeAmount[$c]) {
              $j=$H+1;
              $i=$R+1;
              }
            }
          if (($option!=2)&&($firstRow>0)&&($i==($R-1))) $backward=TRUE;
          }
        }
      }
      for ($j=0;$j<$H;++$j)
        for ($i=0;$i<$R;++$i)
          $G[$i][$j][1]=$G[$i][$j][2]=$G[$i][$j][3]=$G[$i][$j][4]=$G[$i][$j][5]=-1;
    }

  function printInformation() {
    global $H,$R,$C,$G,$P;
    for ($i=0;$i<$C;++$i) {
      $info[$i][0]=$info[$i][1]=$info[$i][2]=$info[$i][3]=0; // 1=hari pin, 2=u bend
      $info[$i][4]=$info[$i][5]=$info[$i][6]=$info[$i][7]=0;
      }
    $in[0]=$in[1]=$in[2]=0;
    $in[4]=$in[5]=$in[6]=$in[7]=0;
    for ($j=0;$j<$H;++$j) {
      for ($i=0;$i<$R;++$i) {
        if ($G[$i][$j][0]>=0) {
          $info[$G[$i][$j][0]][0]++;
          if (($G[$i][$j][2]>=0)&&($G[$i][$j][3]>=0)&&(($G[$i][$j][1]%2)!=0)) {
            $info[$G[$i][$j][0]][1]++;
            if ($i==$G[$i][$j][2]) $info[$G[$i][$j][0]][4]++;
              else $info[$G[$i][$j][0]][5]++;
            }
          if (($G[$i][$j][2]>=0)&&($G[$i][$j][3]>=0)&&(($G[$i][$j][1]%2)==0)) {
            $info[$G[$i][$j][0]][2]++;
            if ($i==$G[$i][$j][2]) $info[$G[$i][$j][0]][6]++;
              else $info[$G[$i][$j][0]][7]++;
            }
          }
        }
      }
    $fail=routeFail();
    echo '<TABLE BORDER=1><TR><TH ROWSPAN=2>Circuit<BR>#</TH><TH ROWSPAN=2>Success</TH><TH ROWSPAN=2>#<BR>Pipe</TH>';
    echo '<TH COLSPAN=3>#<BR>Hair Pin</TH><TH COLSPAN=3>#<BR>U-Bend</TH><TH ROWSPAN=2>Rule<BR>#</TH></TR>';
    echo '<TR>';
    echo '<TH>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TH><TH>&nbsp;&nbsp;&nbsp;x&nbsp;&nbsp;&nbsp;</TH>';
    echo '<TH>&nbsp;&nbsp;&nbsp;|&nbsp;&nbsp;&nbsp;</TH>';
    echo '<TH>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TH><TH>&nbsp;&nbsp;&nbsp;x&nbsp;&nbsp;&nbsp;</TH>';
    echo '<TH>&nbsp;&nbsp;&nbsp;|&nbsp;&nbsp;&nbsp;</TH>';
    echo '</TR>';
    for($i=0;$i<$C;++$i) {
      $in[0]+=$info[$i][0];
      $in[1]+=$info[$i][1];
      $in[2]+=$info[$i][2];
      $in[4]+=$info[$i][4];
      $in[5]+=$info[$i][5];
      $in[6]+=$info[$i][6];
      $in[7]+=$info[$i][7];
      echo '<TR>';
      echo '<TD ALIGN=CENTER>'.($i+1).'</TD>';
      echo '<TD ALIGN=CENTER '.(($fail[$i]==0)?'STYLE="background-color:green">&#10003':'STYLE="background-color:red"').'</TD>';
      echo '<TD ALIGN=RIGHT>'.$info[$i][0].'</TD>';
      echo '<TD ALIGN=RIGHT>'.$info[$i][1].'</TD><TD ALIGN=RIGHT>'.$info[$i][4].'</TD><TD ALIGN=RIGHT>'.$info[$i][5].'</TD>';
      echo '<TD ALIGN=RIGHT>'.$info[$i][2].'</TD><TD ALIGN=RIGHT>'.$info[$i][6].'</TD><TD ALIGN=RIGHT>'.$info[$i][7].'</TD>';
      echo '<TD ALIGN=RIGHT>'.$P[$i].'</TD>';
      echo '</TR>';
      }
    echo '<TR>';
    echo '<TH ALIGN=RIGHT>Total</TH>';
    echo '<TH ALIGN=CENTER '.(($fail[$C]==0)?'STYLE="background-color:green">&#10003':'STYLE="background-color:red"').'</TH>';
    echo '<TH ALIGN=RIGHT>'.$in[0].'/'.($H*$R).'</TH>';
    echo '<TH ALIGN=RIGHT>'.$in[1].'</TH><TH ALIGN=RIGHT>'.$in[4].'</TH><TH ALIGN=RIGHT>'.$in[5].'</TH>';
    echo '<TH ALIGN=RIGHT>'.$in[2].'</TH><TH ALIGN=RIGHT>'.$in[6].'</TH><TH ALIGN=RIGHT>'.$in[7].'</TH>';
    echo '</TR>';
    echo '</TABLE>';
    }

  if (isset($_REQUEST['Height'])) {
    global $H,$R,$C,$T,$G,$P;
    $H=$_REQUEST['Height'];
    $R=$_REQUEST['Rows'];
    $C=$_REQUEST['Circuits'];
    $T['R']=0;
    if (isset($_REQUEST['Rot'])) $T['R']=$_REQUEST['Rot'];
      else if (($_REQUEST['Rot1']==1)&&($_REQUEST['Rot2']==1)) $T['R']=3;
      else if (($_REQUEST['Rot1']==1)&&($_REQUEST['Rot2']==0)) $T['R']=1;
      else if (($_REQUEST['Rot1']==0)&&($_REQUEST['Rot2']==1)) $T['R']=0;
      else if (($_REQUEST['Rot1']==0)&&($_REQUEST['Rot2']==0)) $T['R']=2;
    $T['P']='N';
    if (isset($_REQUEST['Polarity'])) $T['P']=$_REQUEST['Polarity'];
    $T['O']=1;
    if (isset($_REQUEST['OutRows'])) $T['O']=$_REQUEST['OutRows'];
    $try=3;
    for ($j=0, $min=0;$j<$try;++$j) {
      createGraph($j);
      for ($c=0;$c<$C;++$c) $P[$c]=10000*$j;
      $fail[$j]=findPath();
      if ($fail[$j]==0) $j=100;
        else {
        if ($fail[$min]>$fail[$j]) $min=$j;
        }
      }
/*
    if (($j<100) && ($T['P']=='N')) {
      $T['P']='E';
      for ($j=0, $min=0;$j<$try;++$j) {
        createGraph($j);
        for ($c=0;$c<$C;++$c) $P[$c]=10000*$j;
        $fail[$j]=findPath();
        if ($fail[$j]==0) $j=100;
          else {
          if ($fail[$min]>$fail[$j]) $min=$j;
          }
        }
      $T['P']='N';
      }
    if (($j<100) && ($T['P']=='N')) {
      $T['P']='O';
      for ($j=0, $min=0;$j<$try;++$j) {
        createGraph($j);
        for ($c=0;$c<$C;++$c) $P[$c]=10000*$j;
        $fail[$j]=findPath();
        if ($fail[$j]==0) $j=100;
          else {
          if ($fail[$min]>$fail[$j]) $min=$j;
          }
        }
      $T['P']='N';
      }
 */   if ($j<100) {
      createGraph($min);
      for ($c=0;$c<$C;++$c) $P[$c]=10000*$min;
      findPath();
      }
    if (!isset($_REQUEST['Form1'])) {
      if (isset($_REQUEST['Flip'])) $im=drawGraph(TRUE); else $im=drawGraph(FALSE);
      header('Content-Type: image/png');
      ImagePNG($im);
      ImageDestroy($im);
      }
    }
  ?>

<HTML>
<HEAD>
</HEAD>
<BODY>
  <TABLE>
  <TR><TD VALIGN=TOP>
  <H2>Automatic Routing System</H2>
  <FORM METHOD=POST>
    <LABEL FOR="Height">Height (จำนวนท่อแนวตั้ง)</LABEL>           <INPUT TYPE="text" ID="Height" NAME="Height" VALUE=<?php echo (isset($H)) ? $H : 10; ?> SIZE=2> <BR>
    <LABEL FOR="Rows">Number of Rows (จำานวนแถว)</LABEL>        <INPUT TYPE="text" ID="Rows" NAME="Rows" VALUE=<?php echo (isset($R)) ? $R : 5; ?> SIZE=2> <BR>
    <LABEL FOR="Circuits">Number of Circuits (จำนวนวงจร)</LABEL> <INPUT TYPE="text" ID="Circuits" NAME="Circuits" VALUE=<?php echo (isset($C)) ? $C : 2; ?> SIZE=2> <BR>
    <BR>
    Force outlet (บังคับรูออก):
    <SELECT ID="Polarity" NAME="Polarity">
      <!OPTION VALUE="N" <?php echo ($_REQUEST['Polarity']=='N') ? 'SELECTED' : ''; ?>><!No Preference (ไม่บังคับ)</OPTION>
      <OPTION VALUE="E" <?php echo ($_REQUEST['Polarity']=='E') ? 'SELECTED' : ''; ?>>Same as inlet (ทางเดียวกับทางเข้า)</OPTION>
      <OPTION VALUE="O" <?php echo ($_REQUEST['Polarity']=='O') ? 'SELECTED' : ''; ?>>Opposite size (ตรงกันข้ามกับทางเข้า)</OPTION>
    </SELECT>
    <BR>
    Coil Type (ชนิดของคอยล์):
    <SELECT ID="Rot1" NAME="Rot1">
      <OPTION VALUE="1" <?php echo ($_REQUEST['Rot1']=='1') ? 'SELECTED' : ''; ?>>Water Coil (คอยล์น้ำ) / Evap. Coil (คอยล์เย็น)</OPTION>
      <OPTION VALUE="0" <?php echo ($_REQUEST['Rot1']=='0') ? 'SELECTED' : ''; ?>>Condenser Coil (คอยล์ร้้อน)</OPTION>
    </SELECT>
    <BR>
    Coil Arrangement (การจัดเรียงคอลย์):
    <SELECT ID="Rot2" NAME="Rot2">
      <OPTION VALUE="1" <?php echo ($_REQUEST['Rot2']=='1') ? 'SELECTED' : ''; ?>>Normal (ปกติ)</OPTION>
      <OPTION VALUE="0" <?php echo ($_REQUEST['Rot2']=='0') ? 'SELECTED' : ''; ?>>Invert (สลับ)</OPTION>
    </SELECT>
    <BR>
    <BR>
    Number of Outlet Rows (แนวท่อออก):
    <SELECT ID="OutRows" NAME="OutRows">
      <OPTION VALUE="1" <?php echo ($_REQUEST['OutRows']=='1') ? 'SELECTED' : ''; ?>>Best One (หัวมุมแถวสุดท้าย)</OPTION>
      <OPTION VALUE="2" <?php echo ($_REQUEST['OutRows']=='2') ? 'SELECTED' : ''; ?>>Last Row (แถวสุดท้าย)</OPTION>
      <OPTION VALUE="3" <?php echo ($_REQUEST['OutRows']=='3') ? 'SELECTED' : ''; ?>>Two Last Row (สองแถวสุดท้าย)</OPTION>
      <OPTION VALUE="4" <?php echo ($_REQUEST['OutRows']=='4') ? 'SELECTED' : ''; ?>>Multiple (หลายรู)</OPTION>
    </SELECT>
    <BR>
    <BR>
    <INPUT TYPE="submit" NAME="Form1" VALUE="Run"> <BR>
  </FORM>
  <?php
    if (isset($_REQUEST['Form1'])) {
      $Rot=$T['R'];
      printInformation();
      }
    ?>
  <H4>Copyright 2021 by C. I. Group Public Company Limited</H4>
  </TD><TD>
  <CENTER>Front View</CENTER>
  <?php
    if (isset($_REQUEST['Form1'])) {
      echo "<IMG SRC='index.php?Height=$H&Rows=$R&Circuits=$C&Polarity=".$_REQUEST['Polarity']."&OutRows=".$_REQUEST['OutRows']."&Rot=$Rot' WIDHT='50%' HEIGHT='80%'>";
      }
    ?>
  </TD><TD>
  <CENTER>Back View</CENTER>
  <?php
    if (isset($_REQUEST['Form1'])) {
      echo "<IMG SRC='index.php?Height=$H&Rows=$R&Circuits=$C&Polarity=".$_REQUEST['Polarity']."&OutRows=".$_REQUEST['OutRows']."&Rot=$Rot&Flip='T' WIDHT='50%' HEIGHT='80%'>";
      }
    ?>
  </TD></TR></TABLE>
</BODY>
</HTML>
