<?php
  require 'route.php';
  require 'draw.php';

  function createGraph($option) {
    global $H,$R,$C,$T,$G;
    $holePerCircuit=($H*$R)/$C;
    $sum=0;
    $TT=$T['P'];
    if ($option==2) { $TT='O'; $option=0; }
    if ($option==3) { $TT='O'; $option=1; }
    if ($option==4) { $TT='E'; $option=0; }
    if ($option==5) { $TT='E'; $option=1; }
    for ($c=0;$c<$C;++$c) {
      $holeAmount[$c]=floor(($c+1)*$holePerCircuit)-$sum;
      if ($TT=='E') if (($holeAmount[$c]%2)!=0) { $holeAmount[$c]--;}
      if ($TT=='O') if (($holeAmount[$c]%2)==0) { $holeAmount[$c]--;}
      $sum+=$holeAmount[$c];
      }
    $k=$c=0;
    for ($j=0;$j<$H;++$j) for ($i=0;$i<$R;++$i) $G[$i][$j][0]=-1;
    for ($c=0;$c<$C;++$c) {
      // for ($j=0;($j<$H)&&($G[0][$j][0]>=0);++$j);
      // $G[0][$j][0]=$c;
      $k=0;
      $backward=FALSE;
      $firstRow=-1;
      for ($j=0;$j<$H;++$j) {
        for ($i=0;$i<$R;++$i) {
          if ($backward==FALSE) $ii=$i;
            else if (($option&1)==0) $ii=$R-$i-1;
            else if (($option&1)==1) if (($R%2)!=0) $ii=((($R-$i)*2)-1)%$R;
            else if (($option&1)==1) $ii=((($R-$i)*2)-1)%($R+1);
          if ($G[$ii][$j][0]<0) {
            $firstRow=1;
            $G[$ii][$j][0]=$c;
            $k++;
            if ($k>=$holeAmount[$c]) {
              $j=$H+1;
              $i=$R+1;
              }
            }
          if (($firstRow>0) && ($ii==($R-1))) $backward=TRUE;
          }
        }
      }
    }

  function printInformation() {
    global $H,$R,$C,$G,$P;
    for ($i=0;$i<$C;++$i) $info[$i][0]=$info[$i][1]=$info[$i][2]=$info[$i][3]=0; // 1=hari pin, 2=u bend
    $in[0]=$in[1]=$in[2]=0;
    for ($j=0;$j<$H;++$j) {
      for ($i=0;$i<$R;++$i) {
        if ($G[$i][$j][0]>=0) {
          $info[$G[$i][$j][0]][0]++;
          if (($G[$i][$j][2]>=0)&&($G[$i][$j][3]>=0)&&(($G[$i][$j][1]%2)==0)) $info[$G[$i][$j][0]][1]++;
          if (($G[$i][$j][2]>=0)&&($G[$i][$j][3]>=0)&&(($G[$i][$j][1]%2)!=0)) $info[$G[$i][$j][0]][2]++;
          }
        }
      }
    $fail=routeFail();
    echo '<TABLE BORDER=1><TR><TH>Circuit#</TH><TH>Success</TH><TH># of Pipe</TH>';
    echo '<TH># of Hair Pin</TH><TH># of U-Bend</TH><TH>Rule#</TH></TR>';
    for($i=0;$i<$C;++$i) {
      $in[0]+=$info[$i][0];
      $in[1]+=$info[$i][1];
      $in[2]+=$info[$i][2];
      echo '<TR>';
      echo '<TD ALIGN=CENTER>'.($i+1).'</TD>';
      echo '<TD ALIGN=CENTER '.(($fail[$i]==0)?'STYLE="background-color:green">&#10003':'STYLE="background-color:red"').'</TD>';
      echo '<TD ALIGN=RIGHT>'.$info[$i][0].'</TD>';
      echo '<TD ALIGN=RIGHT>'.$info[$i][1].'</TD>';
      echo '<TD ALIGN=RIGHT>'.$info[$i][2].'</TD>';
      echo '<TD ALIGN=RIGHT>'.$P[$i].'</TD>';
      echo '</TR>';
      }
    echo '<TR>';
    echo '<TH ALIGN=RIGHT>Total</TH>';
    echo '<TH ALIGN=CENTER '.(($fail[$C]==0)?'STYLE="background-color:green">&#10003':'STYLE="background-color:red"').'</TH>';
    echo '<TH ALIGN=RIGHT>'.$in[0].'</TH>';
    echo '<TH ALIGN=RIGHT>'.$in[1].'</TH>';
    echo '<TH ALIGN=RIGHT>'.$in[2].'</TH>';
    echo '</TR>';
    echo '</TABLE>';
    }

  if (isset($_REQUEST['Height'])) {
    global $H,$R,$C,$T,$G,$P;
    $H=$_REQUEST['Height'];
    $R=$_REQUEST['Rows'];
    $C=$_REQUEST['Circuit'];
    $T['R']=0;
    if (isset($_REQUEST['Rot'])) $T['R']=$_REQUEST['Rot'];
    $T['P']='N';
    if (isset($_REQUEST['Polarity'])) $T['P']=$_REQUEST['Polarity'];
    $T['O']=1;
    if (isset($_REQUEST['OutRows'])) $T['O']=$_REQUEST['OutRows'];
    if ($T['P']=='N') $try=6;
      else $try=2;
    for ($j=0, $min=0;$j<$try;++$j) {
      createGraph($j);
      for ($c=0;$c<$C;++$c) $P[$c]=10000*$j;
      $fail[$j]=findPath();
      if ($fail[$j]==0) $j=100;
        else {
        if ($fail[$min]<$fail[$j]) $min=$j;
        }
      }
    if ($j<100) {
      createGraph($min);
      for ($c=0;$c<$C;++$c) $P[$c]=10000*$min;
      findPath();
      }
    if (!isset($_REQUEST['Form1'])) {
      $im=drawGraph();
      header('Content-Type: image/png');
      ImagePNG($im);
      ImageDestroy($im);
      }
    }
  ?>

<HTML>
<HEAD>
</HEAD>
<BODY>
  <TABLE><TR><TD VALIGN=TOP>
  <FORM>
    <INPUT TYPE="submit" NAME="Form1" VALUE="Add Job"> <BR>
    <LABEL FOR="Height">Height</LABEL>              <INPUT TYPE="text" ID="Height" NAME="Height" VALUE=<?php echo (isset($H)) ? $H : 10; ?> SIZE=2> <BR>
    <LABEL FOR="Rows">Number of Rows</LABEL>        <INPUT TYPE="text" ID="Rows" NAME="Rows" VALUE=<?php echo (isset($R)) ? $R : 5; ?> SIZE=2> <BR>
    <LABEL FOR="Circuit">Number of Circuits</LABEL> <INPUT TYPE="text" ID="Circuit" NAME="Circuit" VALUE=<?php echo (isset($C)) ? $C : 2; ?> SIZE=2> <BR>
    <BR>
    Force outlet (บังคับรูออก):
    <SELECT ID="Polarity" NAME="Polarity">
      <OPTION VALUE="N" <?php echo ($_REQUEST['Polarity']=='N') ? 'SELECTED' : ''; ?>>No Preference (ไม่บังคับ)</OPTION>
      <OPTION VALUE="E" <?php echo ($_REQUEST['Polarity']=='E') ? 'SELECTED' : ''; ?>>Same as inlet (ทางเดียวกับทางเข้า)</OPTION>
      <OPTION VALUE="O" <?php echo ($_REQUEST['Polarity']=='O') ? 'SELECTED' : ''; ?>>Opposite size (ตรงกันข้ามกับทางเข้า)</OPTION>
    </SELECT>
    <BR>
    Coil Type (ชนิดของคอยล์):
    <SELECT ID="Rot1" NAME="Rot1">
      <OPTION VALUE="1" <?php echo ($_REQUEST['Rot1']=='1') ? 'SELECTED' : ''; ?>>Water Coil (คอยล์น้ำ) / Evap. Coil (คอยล์เย็น)</OPTION>
      <OPTION VALUE="0" <?php echo ($_REQUEST['Rot1']=='0') ? 'SELECTED' : ''; ?>>Condenser Coil (คอยล์ร้้อน)</OPTION>
    </SELECT>
    <BR>
    Coil Arrangement (การจัดเรียงคอลย์):
    <SELECT ID="Rot2" NAME="Rot2">
      <OPTION VALUE="1" <?php echo ($_REQUEST['Rot2']=='1') ? 'SELECTED' : ''; ?>>Normal (ปกติ)</OPTION>
      <OPTION VALUE="0" <?php echo ($_REQUEST['Rot2']=='0') ? 'SELECTED' : ''; ?>>Invert (สลับ)</OPTION>
    </SELECT>
    <BR>
    Number of Outlet Rows (แนวท่อออก):
    <SELECT ID="OutRows" NAME="OutRows">
      <OPTION VALUE="1" <?php echo ($_REQUEST['OutRows']=='1') ? 'SELECTED' : ''; ?>>Best One (หัวมุมแถวสุดท้าย)</OPTION>
      <OPTION VALUE="2" <?php echo ($_REQUEST['OutRows']=='2') ? 'SELECTED' : ''; ?>>Last Row (แถวสุดท้าย)</OPTION>
      <OPTION VALUE="3" <?php echo ($_REQUEST['OutRows']=='3') ? 'SELECTED' : ''; ?>>Two Last Row (สองแถวสุดท้าย)</OPTION>
      <OPTION VALUE="4" <?php echo ($_REQUEST['OutRows']=='4') ? 'SELECTED' : ''; ?>>Multiple (หลายรู)</OPTION>
    </SELECT>
    <BR>
  </FORM>
  <?php
    if (isset($_REQUEST['Form1'])) {
      if (($_REQUEST['Rot1']==1)&&($_REQUEST['Rot2']==1)) $Rot=3;
        else if (($_REQUEST['Rot1']==1)&&($_REQUEST['Rot2']==0)) $Rot=1;
        else if (($_REQUEST['Rot1']==0)&&($_REQUEST['Rot2']==1)) $Rot=0;
        else if (($_REQUEST['Rot1']==0)&&($_REQUEST['Rot2']==0)) $Rot=2;
      printInformation();
      echo "</TD>";
      echo "<TD><IMG SRC='image.php?Height=$H&Rows=$R&Circuit=$C&Polarity=".$_REQUEST['Polarity']."&OutRows=".$_REQUEST['OutRows']."&Rot=$Rot' WIDHT='100%' HEIGHT='80%'><TD>";
      }
    ?>
  </TR></TABLE>
</BODY>
</HTML>
