<?php

  function moveDownCorner($c,&$i,&$j,$skip=FALSE) {
    global $H,$R,$C,$T,$G;
    if ($skip) return FALSE;
    if ($k=((($j+1)<$H) && ($G[$i][$j+1][0]==$c) && ($G[$i][$j+1][1]==-1) && ($i<($R-1)) && (degreeLeft($i,$j+1)<2))) { $i=$i; $j=$j+1;} // Down Corner
    return $k;
    }

  function moveDown($c,&$i,&$j,$skip=FALSE) {
    global $H,$R,$C,$T,$G;
    if ($skip) return FALSE;
    if (($i%2)!=0) {
      if ($k=((($j+1)<$H) && ($G[$i][$j+1][1]==-1) && ($G[$i][$j+1][0]==$c))) { $i=$i; $j=$j+1;} // Down
      } else {
      if ($k=((($j+1)<$H) && ($G[$i][$j+1][1]==-1) && ($G[$i][$j+1][0]==$c))) { $i=$i; $j=$j+1;}  // Down
      }
    return $k;
    }

  function moveUp($c,&$i,&$j,$skip=FALSE) {
    global $H,$R,$C,$T,$G;
    if ($skip) return FALSE;
    if (($i%2)!=0) {
      if ($k=(($j>0) && ($G[$i][$j-1][1]==-1) && ($G[$i][$j-1][0]==$c))) { $i=$i; $j=$j-1;} // Up
      } else {
      if ($k=(($j>0) && ($G[$i][$j-1][1]==-1) && ($G[$i][$j-1][0]==$c))) { $i=$i; $j=$j-1;} // Up
      }
    return $k;
    }

  function moveForUp($c,&$i,&$j,$skip=FALSE) {
    global $H,$R,$C,$T,$G;
    if ($skip) return FALSE;
    if (($i%2)!=0) {
      if ($k=((($i+1)<$R) && ($G[$i+1][$j][1]==-1) && ($G[$i+1][$j][0]==$c))) { $i=$i+1; $j=$j;} // For Up
      } else {
      if ($k=(($j>0) && (($i-1)<$R) && ($G[$i+1][$j-1][1]==-1) && ($G[$i+1][$j-1][0]==$c))) { $i=$i+1; $j=$j-1;} // For Up
      }
    return $k;
    }

  function moveRevUp($c,&$i,&$j,$skip=FALSE) {
    global $H,$R,$C,$T,$G;
    if ($skip) return FALSE;
    if (($i%2)!=0) {
      if ($k=(($i>0) && ($G[$i-1][$j][1]==-1) && ($G[$i-1][$j][0]==$c))) { $i=$i-1; $j=$j;} // Rev Up
      } else {
      if ($k=(($j>0) && ($i>0) && ($G[$i-1][$j-1][1]==-1) && ($G[$i-1][$j-1][0]==$c))) { $i=$i-1; $j=$j-1;} // Rev Up
      }
    return $k;
    }

  function moveForDown($c,&$i,&$j,$skip=FALSE) {
    global $H,$R,$C,$T,$G;
    if ($skip) return FALSE;
    if (($i%2)!=0) {
      if ($k=((($i+1)<$R) && (($j+1)<$H) && ($G[$i+1][$j+1][1]==-1) && ($G[$i+1][$j+1][0]==$c))) { $i=$i+1; $j=$j+1;} // For Down
      } else {
      if ($k=((($i+1)<$R) && ($G[$i+1][$j][1]==-1) && ($G[$i+1][$j][0]==$c))) { $i=$i+1; $j=$j;}  // For Down
      }
    return $k;
    }

  function moveRevDown($c,&$i,&$j,$skip=FALSE) {
    global $H,$R,$C,$T,$G;
    if ($skip) return FALSE;
    if (($i%2)!=0) {
      if ($k=(($i>0) && (($j+1)<$H) && ($G[$i-1][$j+1][1]==-1) && ($G[$i-1][$j+1][0]==$c))) { $i=$i-1; $j=$j+1;} // Rev Down
      } else {
      if ($k=(($i>0) && ($G[$i-1][$j][1]==-1) && ($G[$i-1][$j][0]==$c))) { $i=$i-1; $j=$j;}  // Rev Down
      }
    return $k;
    }

  function routeFail() {
    global $H,$R,$C,$T,$G;
    for ($i=0;$i<$C;++$i) $info[$i]=0;
    for ($j=0;$j<$H;++$j) {
      for ($i=0;$i<$R;++$i) {
        if ($G[$i][$j][0]>=0) {
          if ($G[$i][$j][1]<0) $info[$G[$i][$j][0]]=-1;
          }
        }
      }
    if (($T['O']==1)||($T['O']==2)) { // Check if all end point is last row
      for ($c=0;$c<$C;++$c) {
        $found=0;
        for ($j=0,$i=($R-1);$j<$H;++$j) if (($c==$G[$i][$j][0])&&($G[$i][$j][2]<0)&&($G[$i][$j][3]<0)) $found=1;
        if ($found==0) $info[$c]=-1;
        }
      }
    if ($T['O']==1) { // Check if all end point is last corner
      for ($j=($H-1),$i=($R-1),$k=-1;$j>=0;--$j) {
        if ($k!=$G[$i][$j][0]) { // Mark last point
          if (($G[$i][$j][2]>=0)&&($G[$i][$j][3]>=0)) $info[$G[$i][$j][0]]=-1;
          $k=$G[$i][$j][0];
          }
        }
      }
    if ($T['O']==3) { // Check if all end point is two last row
      for ($c=0;$c<$C;++$c) {
        $found=0;
        for ($j=0,$i=($R-1);$j<$H;++$j) if (($c==$G[$i][$j][0])&&($G[$i][$j][2]<0)&&($G[$i][$j][3]<0)) $found=1;
        if ($R>=2) for ($j=0,$i=($R-2);$j<$H;++$j) if (($c==$G[$i][$j][0])&&($G[$i][$j][2]<0)&&($G[$i][$j][3]<0)) $found=1;
        if ($found==0) $info[$c]=-1;
        }
      }


    for ($i=0;($i<$C)&&($info[$i]==0);++$i);
    $info[$C]=($i==$C)?0:-1;
    return $info;
    }


  function degreeLeft($i,$j) {
    global $H,$R,$G;
    $c=$G[$i][$j][0];
    $d=0;
    if (($i>0) && ($G[$i-1][$j][1]==-1) && ($G[$i-1][$j][0]==$c)) $d++;
    if ((($i+1)<$R) && ($G[$i+1][$j][1]==-1) && ($G[$i+1][$j][0]==$c)) $d++;
    if (($i%2)==0) {
      if ($j>0) {
        if (($G[$i][$j-1][1]==-1) && ($G[$i][$j-1][0]==$c))$d++;
        if (($i>0) && ($G[$i-1][$j-1][1]==-1) && ($G[$i-1][$j-1][0]==$c)) $d++;
        if ((($i+1)<$R) && ($G[$i+1][$j-1][1]==-1) && ($G[$i+1][$j-1][0]==$c)) $d++;
        }
      if ((($j+1)<$H) && ($G[$i][$j+1][1]==-1) && ($G[$i][$j+1][0]==$c)) $d++;
      } else {
      if (($j+1)<$H) {
        if (($G[$i][$j+1][1]==-1) && ($G[$i][$j+1][0]==$c)) $d++;
        if (($i>0) && ($G[$i-1][$j+1][1]==-1) && ($G[$i-1][$j+1][0]==$c)) $d++;
        if ((($i+1)<$R) && ($G[$i+1][$j+1][1]==-1) && ($G[$i+1][$j+1][0]==$c)) $d++;
        }
      if (($j>0) && ($G[$i][$j-1][1]==-1) && ($G[$i][$j-1][0]==$c)) $d++;
      }
    return $d;
    }
// For kk[][][x] 0 is circuit number (starting from 0)
// For kk[][][x] 1 is routed number (starting from 0)
// For kk[][][x] 2,3 is next vertex
// For kk[][][x] 4,5 is previous vertex
  function resetNode($c) {
    global $H,$R,$C,$T,$G;
    for ($j=0;$j<$H;++$j)
      for ($i=0;$i<$R;++$i)
        if ($G[$i][$j][0]==$c)
          $G[$i][$j][1]=$G[$i][$j][2]=$G[$i][$j][3]=$G[$i][$j][4]=$G[$i][$j][5]=-1;
    }

  function backTrack($c,$level=10000) {
    global $H,$R,$C,$T,$G,$P;
    $max=-1; $iMax=-1; $jMax=-1;
    for ($j=0;$j<$H;++$j)
      for ($i=0;$i<$R;++$i)
        if (($G[$i][$j][0]==$c) && ($G[$i][$j][1]>$max)) { $max=$G[$i][$j][1]; $iMax=$i; $jMax=$j; }
    for ($j=0;$j<($max-1);++$j) {
      $ii=$iMax;
      $jj=$jMax;
      $G[$ii][$jj][1]=-1;
      if ($G[$ii][$jj][2]>=0) $G[$ii][$jj][2]=-1;
      if ($G[$ii][$jj][3]>=0) $G[$ii][$jj][3]=-1;
      // echo $iMax.','.$jMax.','.degreeLeft($G[$iMax][$jMax][4],$G[$iMax][$jMax][5]).'<BR>';
      if (($k=degreeLeft($ii=$G[$iMax][$jMax][4],$jj=$G[$iMax][$jMax][5]))>1) { if ($level>$G[$ii][$jj][1]) $j=$max+1;}
      if ($j<$max) { $iMax=$ii; $jMax=$jj; }
      }
    if ($k>1) { $iMax=$ii; $jMax=$jj; moveUp($c,$ii,$jj);     if (($ii!=$iMax) || ($jj!=$jMax)) $k=0; }
    if ($k>1) { $iMax=$ii; $jMax=$jj; moveDown($c,$ii,$jj);   if (($ii!=$iMax) || ($jj!=$jMax)) $k=0; }
    if ($k>1) { $iMax=$ii; $jMax=$jj; moveForUp($c,$ii,$jj);  if (($ii!=$iMax) || ($jj!=$jMax)) $k=0; }
    if ($k>1) { $iMax=$ii; $jMax=$jj; moveForDown($c,$ii,$jj);if (($ii!=$iMax) || ($jj!=$jMax)) $k=0; }
    if ($k>1) { $iMax=$ii; $jMax=$jj; moveRevUp($c,$ii,$jj);  if (($ii!=$iMax) || ($jj!=$jMax)) $k=0; }
    if ($k>1) { $iMax=$ii; $jMax=$jj; moveRevDown($c,$ii,$jj);if (($ii!=$iMax) || ($jj!=$jMax)) $k=0; }
    if ($k==0) {
      $G[$ii][$jj][1]=$G[$iMax][$jMax][1]+1;
      $G[$ii][$jj][4]=$iMax;
      $G[$ii][$jj][5]=$jMax;
      $G[$iMax][$jMax][2]=$ii;
      $G[$iMax][$jMax][3]=$jj;
      }
    return $G[$iMax][$jMax][1];
    }

  function findPath() {
    global $H,$R,$C,$T,$G,$P;
    $fail=0;
    for ($c=0;$c<$C;++$c) {
      $ii=-1;
      if ($ii<0) {
        resetNode($c); $ii=findPath1($c);
        if ($ii>=0) $P[$c]+=10;
        }
      if ($ii<0) {
        resetNode($c); $ii=findPath2($c);
        if ($ii>=0) $P[$c]+=20;
        }
      if ($ii<0) {
        resetNode($c); $ii=findPath3($c);
        if ($ii>=0) $P[$c]+=10;
        }
      if ($ii<0) {
        resetNode($c); $ii=findPath4($c);
        if ($ii>=0) $P[$c]+=20;
        }
      if ($ii<0) {
        resetNode($c); $ii=findPath101($c);
        if ($ii>=0) $P[$c]+=1010;
          else {
          for ($i=1,$ll=1000;($ii<0)&&($i<5);++$i) { $ll=backTrack($c,$ll); $ii=findPath101($c); }
          if ($ii>=0) $P[$c]+=(1010+$i);
          }
        }
      if ($ii<0) {
        resetNode($c); $ii=findPath102($c);
        if ($ii>=0) $P[$c]+=1020;
          else {
          for ($i=1,$ll=1000;($ii<0)&&($i<5);++$i) { $ll=backTrack($c,$ll); $ii=findPath102($c); }
          if ($ii>=0) $P[$c]+=(1020+$i);
          }
        }
      if ($ii<0) {
        resetNode($c); $ii=findPath103($c);
        if ($ii>=0) $P[$c]+=1030;
          else {
          for ($i=1,$ll=1000;($ii<0)&&($i<5);++$i) { $ll=backTrack($c,$ll); $ii=findPath103($c); }
          if ($ii>=0) $P[$c]+=(1030+$i);
          }
        }
      if ($ii<0) {
        resetNode($c); $ii=findPath104($c);
        if ($ii>=0) $P[$c]+=1040;
          else {
          for ($i=1,$ll=1000;($ii<0)&&($i<5);++$i) { $ll=backTrack($c,$ll); $ii=findPath104($c); }
          if ($ii>=0) $P[$c]+=(1040+$i);
          }
        }
      if ($ii<0) {
        resetNode($c); $ii=findPath101($c);
        $fail++;
        }
      if ((($T['R']==2)||($T['R']==3))&&($ii>0)) {
//      if (($T['R']==2)&&($ii>0)) {
        for ($j=0;$j<$H;++$j) for ($i=0;$i<$R;++$i) if ($G[$i][$j][0]==$c) $G[$i][$j][1]=$ii-$G[$i][$j][1];
        }
      }
/*    if ($T['R']==3) {
      for ($j=0;$j<($H/2);++$j) for ($i=0;$i<$R;++$i) {
        for ($k=0;$k<6;++$k) { $aa=$G[$i][$j][$k];  $G[$i][$j][$k]=$G[$i][$H-$j][$k];  $G[$i][$H-$j][$k]=$aa; }
        }
      }*/
    if (($T['R']==1)||($T['R']==2)) {
      for ($j=0;$j<$H;++$j) for ($i=0;$i<$R;++$i) if ($G[$i][$j][0]>=0) $G[$i][$j][0]=$C-$G[$i][$j][0]-1;
      }
    return $fail;
    }

  function prepareNode($c,&$i,&$j) {
    global $H,$R,$C,$T,$G;
    for ($j=0;$j<$H;++$j)
      for ($i=0;$i<$R;++$i)
        if (($G[$i][$j][0]==$c)&&($G[$i][$j][1]<0))
          $G[$i][$j][1]=$G[$i][$j][2]=$G[$i][$j][3]=$G[$i][$j][4]=$G[$i][$j][5]=-1;
    for ($j=0;($j<$H)&&($G[0][$j][0]!=$c);++$j);
    $i=0; $G[$i][$j][1]=0;  $index=0;
    $holePerCircuit=($H*$R)/$C;
    for ($k=0;$k<($holePerCircuit+4);++$k) {
      if (($G[$i][$j][2]>=0) && ($G[$i][$j][3]>=0) && ($G[$G[$i][$j][2]][$G[$i][$j][3]][0]==$c)) {
        $ii=$G[$i][$j][2];
        $jj=$G[$i][$j][3];
        $i=$ii; $j=$jj;
        }
      }
    }

  function findPath104($c) {
    global $H,$R,$C,$T,$G;
    $holePerCircuit=($H*$R)/$C;
    prepareNode($c,$i,$j);

    for ($k=0;$k<($holePerCircuit+4);++$k) {
      $iOld=$i;  $jOld=$j;
      if (!moveDownCorner($c,$i,$j))
        if (!moveDown($c,$i,$j))
        if (!moveUp($c,$i,$j))
        if (!moveForDown($c,$i,$j))
        if (!moveRevDown($c,$i,$j))
        if (!moveForUp($c,$i,$j))
          moveRevUp($c,$i,$j);
      if ($G[$i][$j][1]==-1) {
        $index=$G[$iOld][$jOld][1]+1; $G[$i][$j][1]=$index;
        $G[$iOld][$jOld][2]=$i; $G[$iOld][$jOld][3]=$j;
        $G[$i][$j][4]=$iOld; $G[$i][$j][5]=$jOld;
        }
      }
    $rr=routeFail()[$c];
    return ($rr==0) ? $index : $rr;
    }

  function findPath103($c) {
    global $H,$R,$C,$T,$G;
    $holePerCircuit=($H*$R)/$C;
    prepareNode($c,$i,$j);

    for ($k=0;$k<($holePerCircuit+4);++$k) {
      $iOld=$i;  $jOld=$j;
      if (!moveDownCorner($c,$i,$j))
        if (!moveUp($c,$i,$j))
        if (!moveDown($c,$i,$j))
        if (!moveRevUp($c,$i,$j))
        if (!moveRevDown($c,$i,$j))
        if (!moveForUp($c,$i,$j))
        moveForDown($c,$i,$j);
      if ($G[$i][$j][1]==-1) {
        $index=$G[$iOld][$jOld][1]+1; $G[$i][$j][1]=$index;
        $G[$iOld][$jOld][2]=$i; $G[$iOld][$jOld][3]=$j;
        $G[$i][$j][4]=$iOld; $G[$i][$j][5]=$jOld;
        }
      }
    $rr=routeFail()[$c];
    return ($rr==0) ? $index : $rr;
    }

  function findPath102($c) {
    global $H,$R,$C,$T,$G;
    $holePerCircuit=($H*$R)/$C;
    prepareNode($c,$i,$j);

    for ($k=0;$k<($holePerCircuit+4);++$k) {
      $iOld=$i;  $jOld=$j;
      if (!moveDownCorner($c,$i,$j))
        if (!moveUp($c,$i,$j))
        if (!moveRevUp($c,$i,$j))
        if (!moveRevDown($c,$i,$j))
        if (!moveForUp($c,$i,$j))
        if (!moveDown($c,$i,$j))
        moveForDown($c,$i,$j);
      if ($G[$i][$j][1]==-1) {
        $index=$G[$iOld][$jOld][1]+1; $G[$i][$j][1]=$index;
        $G[$iOld][$jOld][2]=$i; $G[$iOld][$jOld][3]=$j;
        $G[$i][$j][4]=$iOld; $G[$i][$j][5]=$jOld;
        }
      }
    $rr=routeFail()[$c];
    return ($rr==0) ? $index : $rr;
    }

  function findPath101($c) {
    global $H,$R,$C,$T,$G;
    $holePerCircuit=($H*$R)/$C;
    prepareNode($c,$i,$j);

    for ($k=0;$k<($holePerCircuit+4);++$k) {
      $iOld=$i;  $jOld=$j;
      if (!moveDownCorner($c,$i,$j))
        if (!moveRevUp($c,$i,$j))
        if (!moveForUp($c,$i,$j))
        if (!moveUp($c,$i,$j))
        if (!moveRevDown($c,$i,$j))
        if (!moveForDown($c,$i,$j))
        moveDown($c,$i,$j);
      if ($G[$i][$j][1]==-1) {
        $index=$G[$iOld][$jOld][1]+1; $G[$i][$j][1]=$index;
        $G[$iOld][$jOld][2]=$i; $G[$iOld][$jOld][3]=$j;
        $G[$i][$j][4]=$iOld; $G[$i][$j][5]=$jOld;
        }
      }
    $rr=routeFail()[$c];
    return ($rr==0) ? $index : $rr;
    }

  function findPath4($c) {
    global $H,$R,$C,$T,$G;
    $holePerCircuit=($H*$R)/$C;
    prepareNode($c,$i,$j);

    for ($k=0;$k<($holePerCircuit+4);++$k) {
      $iOld=$i;  $jOld=$j;
      if (!moveDownCorner($c,$i,$j,($index%2)!=0))
        if (!moveDown($c,$i,$j,($index%2)!=0))
        if (!moveUp($c,$i,$j,($index%2)!=0))
        if (!moveForDown($c,$i,$j))
        if (!moveRevDown($c,$i,$j))
        if (!moveForUp($c,$i,$j))
          moveRevUp($c,$i,$j);
      if ($G[$i][$j][1]==-1) {
        $index=$G[$iOld][$jOld][1]+1; $G[$i][$j][1]=$index;
        $G[$iOld][$jOld][2]=$i; $G[$iOld][$jOld][3]=$j;
        $G[$i][$j][4]=$iOld; $G[$i][$j][5]=$jOld;
        }
      }
    $rr=routeFail()[$c];
    return ($rr==0) ? $index : $rr;
    }

  function findPath3($c) {
    global $H,$R,$C,$T,$G;
    $holePerCircuit=($H*$R)/$C;
    prepareNode($c,$i,$j);

    for ($k=0;$k<($holePerCircuit+4);++$k) {
      $iOld=$i;  $jOld=$j;
      if (!moveDownCorner($c,$i,$j,($index%2)!=0))
        if (!moveUp($c,$i,$j,($index%2)!=0))
        if (!moveDown($c,$i,$j,($index%2)!=0))
        if (!moveRevUp($c,$i,$j))
        if (!moveRevDown($c,$i,$j))
        if (!moveForUp($c,$i,$j))
        moveForDown($c,$i,$j);
      if ($G[$i][$j][1]==-1) {
        $index=$G[$iOld][$jOld][1]+1; $G[$i][$j][1]=$index;
        $G[$iOld][$jOld][2]=$i; $G[$iOld][$jOld][3]=$j;
        $G[$i][$j][4]=$iOld; $G[$i][$j][5]=$jOld;
        }
      }
    $rr=routeFail()[$c];
    return ($rr==0) ? $index : $rr;
    }

  function findPath2($c) {
    global $H,$R,$C,$T,$G;
    $holePerCircuit=($H*$R)/$C;
    prepareNode($c,$i,$j);

    for ($k=0;$k<($holePerCircuit+4);++$k) {
      $iOld=$i;  $jOld=$j;
      if (!moveDownCorner($c,$i,$j,($index%2)!=0))
        if (!moveUp($c,$i,$j,($index%2)!=0))
        if (!moveRevUp($c,$i,$j))
        if (!moveRevDown($c,$i,$j))
        if (!moveForUp($c,$i,$j))
        if (!moveDown($c,$i,$j,($index%2)!=0))
        moveForDown($c,$i,$j);
      if ($G[$i][$j][1]==-1) {
        $index=$G[$iOld][$jOld][1]+1; $G[$i][$j][1]=$index;
        $G[$iOld][$jOld][2]=$i; $G[$iOld][$jOld][3]=$j;
        $G[$i][$j][4]=$iOld; $G[$i][$j][5]=$jOld;
        }
      }
    $rr=routeFail()[$c];
    return ($rr==0) ? $index : $rr;
    }

  function findPath1($c) {
    global $H,$R,$C,$T,$G;
    $holePerCircuit=($H*$R)/$C;
    prepareNode($c,$i,$j);


    for ($k=0;$k<($holePerCircuit+4);++$k) {
      $iOld=$i;  $jOld=$j;
      if (!moveDownCorner($c,$i,$j,($index%2)!=0))
        if (!moveRevUp($c,$i,$j))
        if (!moveForUp($c,$i,$j))
        if (!moveUp($c,$i,$j,($index%2)!=0))
        if (!moveRevDown($c,$i,$j))
        if (!moveForDown($c,$i,$j))
        moveDown($c,$i,$j,($index%2)!=0);
      if ($G[$i][$j][1]==-1) {
        $index=$G[$iOld][$jOld][1]+1; $G[$i][$j][1]=$index;
        $G[$iOld][$jOld][2]=$i; $G[$iOld][$jOld][3]=$j;
        $G[$i][$j][4]=$iOld; $G[$i][$j][5]=$jOld;
        }
      }
    $rr=routeFail()[$c];
    return ($rr==0) ? $index : $rr;
    }

  ?>
